#include<avr/io.h>
#include<util/delay.h>
#include <avr/interrupt.h>

////////////////////////////////////////////////////////////
unsigned long int freq;
unsigned int i=0 , dur , x ,z ;
float freqf1 ,y;
char display ;double freqf ;

////////////////////////////////////////////////////////////
	
	ISR (TIMER1_OVF_vect)
	{
	i++; // count the number of overflows in one second
	}
///////////////////////////////////////////////////////////


int main(void)
{		DDRB = 0xFF;
		sei();
		TIMSK=0x04;
		
	
	while(1)
	{
	//////////////////////////////////////////////////////////
	/* programing to calculate the freq form from freq generator */
	TIMSK = (1<<TOIE1); 	// Timer(s)/Counter(s) Interrupt(s) initialization
	TCCR1B = 0x70;	/* start timer1 with external pulses (T1 rising edge) */
	_delay_ms(1000);
	TCCR1B = 0x00; 	//stop timer1
	TIMSK= 0x00; 	//disable interrupt
	dur= TCNT1; 	/* store the number of counts in TCNT1 register */
	freq = dur + i*65536;	 /* calculate the frequency */
	TCNT1=0x0000;	/* clear TCNT1 register for the next reading */
	i=0;			/* clear number of overflows in one second for the next reading */
////////////////////////////////////////////////////////////////////////////
	/* programing to calculate the value of 0CR0 . frequency will be from 0 to 4M*/
	freqf1 = freq/40000;	//divide freq by 40,000 suppose if freq is 2M.2M/40,000=50 means generate 50% duty cycle 
	y = (freqf1*256)/100;	//formula for fast pwm non inverted mode 
	z = y - 1 ;	// calculate value of 0cro
	OCR0 = z;	//
	_delay_ms(1000);
	TCCR0=0x6B;	//set fast pwm non inverted mode
/////////////////////////////////////////////////////////////////////
}
}



		

		

	


